level:			db	$31,$2a,$3b,$2a,$31,$00
getrdymsg:		db	$2c,$2a,$39,$00,$37,$2a,$26,$29,$3e
hurry:			db	$2d,$3a,$37,$37,$3e,0,0,0,$2d+$80,$3a+$80,$37+$80,$37+$80,$3e+$80
aott:			db	$26,$33,$3e,$34,$33,$2a,$00,$39,$2d,$2a,$37,$2a,$0f

aot:
	ld		hl,(D_FILE)
	ld		de,11*33+11
	add		hl,de
	ex		de,hl
	ld		hl,aott
	ld		bc,13
	ldir

	ld		b,0
_aotw
	call	wvs
	djnz	_aotw
	ret


	.MODULE getready

GR_TIMER	.equ	OUSER+0
GR_POS		.equ	OUSER+2

getready:
	ld		(iy+GR_TIMER),50

_loop
	ld		hl,(D_FILE)
	ld		de,11*33+13
	add		hl,de

	ld		de,getrdymsg
	ex		de,hl
	ld		bc,9
	ldir

	YIELD
	dec		(iy+GR_TIMER)
	jr		nz,_loop

	; clr text
	ld		hl,(D_FILE)
	ld		de,11*33+13
	add		hl,de
	ld		d,h
	ld		e,l
	inc		de
	ld		(hl),0
	ld		bc,8
	ldir


	call	getobject
	ld		bc,levelator
	call	initobject
	call	insertobject_afterhead

	DIE



	

	.MODULE levelator
	
levelator:
	ld		(iy+GR_TIMER),50

	ld		a,(LEVEL)
	inc		a
	ld		(LEVEL),a


_loop
	ld		hl,(D_FILE)
	ld		de,11*33+13
	add		hl,de
	ld		de,level
	ex		de,hl
	ld		bc,6
	ldir

	ld		a,(LEVEL)
	ld		l,a
	ld		h,0
	call	decout10

	YIELD
	dec		(iy+GR_TIMER)
	jr		nz,_loop

	; clear text
	ld		hl,(D_FILE)
	ld		de,11*33+13
	add		hl,de
	ld		d,h
	ld		e,l
	inc		de
	ld		(hl),0
	ld		bc,8
	ldir

	xor		a
	ld		(TIMERRESET),a
	
	call	getobject
	ld		bc,targetgenerator
	call	initobject
	call	insertobject_afterhead

	call	getobject
	ld		bc,blaster
	call	initobject
	call	insertobject_afterhead

	call	getobject
	ld		bc,timer
	call	initobject
	call	insertobject_beforehead

	DIE





	;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	;
	.MODULE bdwaiter

gotable:
	dw	end_gameblack,end_overclear
	dw	end_gameblack,end_overclear
	dw	end_gamegrey,end_overclear
	dw	end_gameclear,end_overclear
	dw	end_gameclear,end_overgrey
	dw	end_gameclear,end_overblack
	dw	end_gameclear,end_overblack
	dw	end_gameclear,end_overgrey
	dw	end_gameclear,end_overclear
	dw	end_gamegrey,end_overclear

bdwaiter:
	IDENT('X')
	YIELD

	ld		a,(ACTIVETGTCT)
	or		a
	jr		nz,bdwaiter

	; delay until k/b reading activates
	ld		(IY+OUSER+2),255
	ld		(IY+OUSER+4),-1

	ld		de,(D_FILE)
	inc		de
	ld		hl,end_gameclear
	call	rle

_gameover
	inc		(IY+OUSER+4)
	ld		a,(IY+OUSER+4)
	cp		9
	jr		nz,_gameoverNc

	ld		(IY+OUSER+4),-1

_gameoverNc
	sla		a
	sla		a
	ld		e,a
	ld		d,0
	ld		hl,gotable
	add		hl,de
	ld		(_g1+1),hl
	inc		hl
	inc		hl
	ld		(_g2+1),hl
	nop
	nop
	nop
	nop
_g2
	ld		hl,(0)
	push	hl
_g1
	ld		hl,(0)
	push	hl

	ld		de,(D_FILE)
	ld		hl,67
	add		hl,de
	pop		de
	ex		de,hl
	call	rle

	ld		de,(D_FILE)
	ld		hl,364
	add		hl,de
	pop		de
	ex		de,hl
	call	rle

	ld		a,(IY+OUSER+2)
	or		a
	jr		nz,_noadvice

	ld		hl,(D_FILE)
	ld		de,11*33+11
	add		hl,de
	ex		de,hl
	ld		hl,aott
	ld		bc,13
	ldir

_noadvice
	ld		(IY+OUSER),7

_deely1
	; wait in this loop for a little while, or until a key is pressed
	IDENT('X')
	YIELD

	call	retTime
	jr		c,_startAgain

	dec		(IY+OUSER)
	jr		nz,_deely1

	jp		_gameover

_startAgain
	call	resetgm
	DIE




retTime:
	ld		a,(IY+OUSER+2)
	or		a
	jr		z,isKeyPressed

	; we won't ever roll this value over (thus returning with carry set)
	; this path is not taken when the value in a is 0, so we can rely
	; on the fact that carry is clear from the OR above.
	;
	dec		(IY+OUSER+2)
	ret

isKeyPressed:
	call	$1ffe
	or		7
	ld		c,a
	ld		a,(LAST_K)
	and		c
	; exits with carry set if a key is pressed
	sub		$ff
	ret
