#include <stdio.h>



void GenTab(int* primary, int* or, const char* name, bool isEven = false)
{
	int out[6];

	for( int i = 0; i < 6; ++i)
	{
		int val = primary[i] | or[i];
		if (val > 7)
		{
			val = (15 - val) | 128;
		}
		out[i] = val;
	}

	if (isEven)
	{
		printf(	"\t; %s\n"
				"%s_e:\n"
				"\tld\t\t(hl),%d\n"
				"\tld\t\ta,%d\n"
				"\tld\t\t(de),a\n"
				"\tinc\t\thl\n"
				"\tinc\t\tde\n"
				"\tld\t\t(hl),%d\n"
				"\tld\t\ta,%d\n"
				"\tld\t\t(de),a\n"
				"\tand\t\ta\n"
				"\tret\n",

				name,name,
				out[0],out[3],out[1],out[4]
		);
	}
	else
	{
		printf(	"%s_o:\n"
				"\tld\t\t(hl),%d\n"
				"\tld\t\ta,%d\n"
				"\tld\t\t(de),a\n"
				"\tinc\t\thl\n"
				"\tinc\t\tde\n"
				"\tld\t\t(hl),%d\n"
				"\tld\t\ta,%d\n"
				"\tld\t\t(de),a\n"
				"\tinc\t\thl\n"
				"\tinc\t\tde\n"
				"\tld\t\t(hl),%d\n"
				"\tld\t\ta,%d\n"
				"\tld\t\t(de),a\n"
				"\tscf\n"
				"\tret\n",

				name,
				out[0],out[3],out[1],out[4],out[2],out[5]
		);
	}
}

void main(void)
{
	int even[] = { 6,9,0, 9,6,0 };
	int odd[] = { 8,3,4, 2,12,1 };
	int eraser[] = { 0,0,0, 0,0,0 };

	// backslash
	int p0e[] = { 8,0,0, 0,1,0 };
	int p0o[] = { 0,4,0, 0,2,0 };

	// fwdslash
	int p1e[] = { 0,4,0, 2,0,0 };
	int p1o[] = { 0,8,0, 0,1,0 };

	// topline
	int p2e[] = { 8,4,0, 0,0,0 };
	int p2o[] = { 0,12,0, 0,0,0 };

	// bottomline
	int p3e[] = { 0,0,0, 2,1,0 };
	int p3o[] = { 0,0,0, 0,3,0 };

	// leftline
	int p4e[] = { 8,0,0, 2,0,0 };
	int p4o[] = { 0,4,0, 0,1,0 };

	// rightline
	int p5e[] = { 0,4,0, 0,1,0 };
	int p5o[] = { 0,8,0, 0,2,0 };

	// allblack
	int p6e[] = { 8,4,0, 2,1,0 };
	int p6o[] = { 0,12,0, 0,3,0 };

	// clear
	int p7e[] = { 0,0,0, 0,0,0 };
	int p7o[] = { 0,0,0, 0,0,0 };


	GenTab(even,p0e,"backslash",true);
	GenTab(odd,p0o,"backslash");

	GenTab(even,p1e,"fwdslash",true);
	GenTab(odd,p1o,"fwdslash");

	GenTab(even,p2e,"topline",true);
	GenTab(odd,p2o,"topline");

	GenTab(even,p3e,"bottomline",true);
	GenTab(odd,p3o,"bottomline");

	GenTab(even,p4e,"leftline",true);
	GenTab(odd,p4o,"leftline");

	GenTab(even,p5e,"rightline",true);
	GenTab(odd,p5o,"rightline");

	GenTab(even,p6e,"allblack",true);
	GenTab(odd,p6o,"allblack");

	GenTab(even,p7e,"clear",true);
	GenTab(odd,p7o,"clear");

	GenTab(eraser,p7e,"eraser",true);
	GenTab(eraser,p7o,"eraser");
}
