// xlzx.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <tchar.h>

#include <iostream>
#include <map>

//  ____0___1___2___3___4___5___6___7___8___9___A___B___C___D___E___F
//  00 SPC GRA GRA GRA GRA GRA GRA GRA GRA GRA GRA  "  GBP  $   :   ?
//  10  (   )   >   <   =   +   -   *   /   ;   ,   .   0   1   2   3
//  20  4   5   6   7   8   9   A   B   C   D   E   F   G   H   I   J
//  30  K   L   M   N   O   P   Q   R   S   T   U   V   W   X   Y   Z

typedef std::map<char,char> CHARMAP;

int main(int argc, char* argv[])
{
	if (argc < 2)
		return 1;

	//

	CHARMAP charmap;

	char c = 0x0b;
	charmap['"'] = c++;
	charmap[''] = c++;
	charmap['$'] = c++;
	charmap[':'] = c++;
	charmap['?'] = c++;
	charmap['('] = c++;
	charmap[')'] = c++;
	charmap['>'] = c++;
	charmap['<'] = c++;
	charmap['='] = c++;
	charmap['+'] = c++;
	charmap['-'] = c++;
	charmap['*'] = c++;
	charmap['/'] = c++;
	charmap[';'] = c++;
	charmap[','] = c++;
	charmap['.'] = c;

	charmap[' '] = 0;

	int i;
	for (i = 0; i < 10; ++i)
	{
		charmap['0'+i] = char(0x1c + i);
	}
	for (i = 0; i < 26; ++i)
	{
		charmap['A'+i] = char(0x26 + i);
	}

	for (i = 0; i < int(strlen(argv[1])); ++i)
	{
		char c = toupper(argv[1][i]);

		char translated = 0x1b; // '.'

		CHARMAP::iterator it = charmap.find(c);
		if (it != charmap.end())
		{
			translated = it->second;
		}

		if ((i % 16) != 0)
		{
			std::cout << ",";
		}
		else if ((i % 16) == 15)
		{
			std::cout << std::endl;
		}

		char p1 = translated / 16;
		if (p1 < 10)
		{
			p1 += '0';
		}
		else
		{
			p1 += 'a' - 10;
		}

		char p2 = translated & 15;
		if (p2 < 10)
		{
			p2 += '0';
		}
		else
		{
			p2 += 'a' - 10;
		}

		std::cout << "$" << p1 << p2;
	}

	return 0;
}

