


	;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	;
	.MODULE	timer

TI_TIME			.equ	OUSER+0
TI_RATE			.equ	OUSER+2

tpenalty:
	.dw		0

timer:
	FPINIT(TI_TIME, 40, 0)
	ld		a,(LEVEL)
	srl		a
	add		a,5
	ld		(iy+TI_RATE),a

_reset
	ld		hl,(D_FILE)
	ld		de,23*33+22
	add		hl,de
	ld		b,10

_resetline
	ld		(hl),128
	inc		hl
	djnz	_resetline

	;

_timerloop
	; get original integer part of TI_TIME into c then
	; adjust the time value using TI_RATE. 
	ld		c,(iy+TI_TIME)
	ld		b,(iy+TI_RATE)
	FPSUB(TI_TIME, 0, b)

	ld		a,(tpenalty)
	ld		b,a
	xor		a
	ld		(tpenalty),a
	FPSUB(TI_TIME, b, 0)

	; if int part has gone negative, time is up!
	bit		7,a
	jr		nz,_alarm

	push	af
	
	; has the int-part changed?
	cp		c
	jr		z,_noupdate

	; yep.

	; whole block graphic
	ld		c,128

	; need to draw a half-block?
	srl		a
	srl		a
	jr		c,_nothalf

	; 
	ld		c,5

_nothalf
	ld		hl,(D_FILE)
	ld		de,23*33+22
	add		hl,de
	ld		e,a
	ld		d,0
	add		hl,de

	ld		(hl),c
	inc		hl
	ld		(hl),0

_noupdate
	pop		af
	cp		8
	jr		nc,_nothurrying

	ld		hl,FRAMES
	ld		a,(hl)

	ld		hl,(D_FILE)
	ld		de,23*33+28
	add		hl,de
	ex		de,hl
	ld		hl,hurry
	ld		bc,5

	and		1
	sla		a
	sla		a
	sla		a
	add		a,l
	ld		l,a
	ldir

_nothurrying
	IDENT('C')
	YIELD

	; go away when the last target is shot
	;
	ld		a,(TIMERRESET)
	or		a
	jr		z,_timerloop

	; yeuch - this is so wrong
	DIE


_alarm
	; clock has reached zero
	;
	ld		hl,(D_FILE)
	ld		de,23*33+22
	add		hl,de
	ld		b,11
_clr
	ld		(hl),0
	inc		hl
	djnz	_clr

	call	getobject
	ld		bc,bdwaiter
	call	initobject
	call	insertobject_afterhead

	ld		a,1
	ld		(TIMEOUT),a

	DIE
